import * as Redux from 'redux';
export declare namespace Imdux {
    interface States {
        [key: string]: State<any, any>;
    }
    interface State<S = any, R = any> {
        initialState: S;
        reducers: R;
    }
    interface Services {
        [key: string]: Services | Service;
    }
    type Service = (args: any) => any;
    type Draft = (payload: any) => void;
    interface Reducer {
        [key: string]: Draft | Reducer;
    }
    type InferState<T extends Imdux.States> = {
        [K in keyof T]: T[K]['initialState'];
    };
    interface Options {
        name?: string;
        devtool?: boolean;
        showRefChanges?: boolean;
    }
    interface Store<S extends Imdux.States> {
        Dispatch: InferDispatch<S>;
        State: InferState<S>;
        redux: Redux.Store<any, Redux.AnyAction>;
    }
    type InferDispatch<T extends Imdux.States> = {
        [K in keyof T]: T[K]['reducers'];
    };
}
